"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reactNative = require("react-native");

const {
  AesGcmCrypto
} = _reactNative.NativeModules;

const toUint8Array = arr => new Uint8Array(arr);

const WiredAesGcmCrypto = {
  encrypt: async (...args) => {
    const nativeArgs = [...args.map(a => [...a])];

    while (nativeArgs.length < 4) {
      nativeArgs.push(null);
    }

    const r = await AesGcmCrypto.encrypt(...nativeArgs);
    return Object.getOwnPropertyNames(r).reduce((last, curr) => ({ ...last,
      [curr]: toUint8Array(r[curr])
    }), {});
  },
  decrypt: async (...args) => toUint8Array(await AesGcmCrypto.decrypt(...args)),
  encryptFile: AesGcmCrypto.encryptFile,
  decryptFile: AesGcmCrypto.decryptFile
};
var _default = WiredAesGcmCrypto;
exports.default = _default;
//# sourceMappingURL=index.js.map