export declare type EncryptedData = {
    iv: Uint8Array;
    tag: Uint8Array;
    content: Uint8Array;
};
declare type AesGcmCryptoType = {
    decrypt(ciphertext: Uint8Array, key: Uint8Array, iv: Uint8Array, tag: Uint8Array, associatedData?: Uint8Array): Promise<Uint8Array>;
    decryptFile(inputFilePath: string, outputFilePath: string, key: string, iv: string, tag: string): Promise<boolean>;
    encrypt(plainText: Uint8Array, key: Uint8Array, iv?: Uint8Array, associatedData?: Uint8Array): Promise<EncryptedData>;
    encryptFile(inputFilePath: string, outputFilePath: string, key: string): Promise<{
        iv: string;
        tag: string;
    }>;
};
declare const _default: AesGcmCryptoType;
export default _default;
